﻿Imports Dapper
Imports Dapper.Contrib.Extensions

Module Module1

    Sub Main()
        SqlMapperExtensions.TableNameMapper = New SqlMapperExtensions.TableNameMapperDelegate(Function(type As Type)
                                                                                                  Return type.Name
                                                                                              End Function)

        Dim Nome As String = String.Empty
        Do
            Console.WriteLine("Digite o nome:")
            Nome = Console.ReadLine()
            If Not String.IsNullOrWhiteSpace(Nome) Then
                Console.WriteLine("Digite o sobrenome:")
                Dim Sobrenome = Console.ReadLine()
                If Not String.IsNullOrWhiteSpace(Sobrenome) Then
                    Dim Pessoa = New Pessoa() With
                    {
                        .Nome = Nome,
                        .Sobrenome = Sobrenome
                    }
                    CadastrarPessoaNoBanco(Pessoa)
                End If
            End If

            ListarPessoas()
        Loop While Not String.IsNullOrWhiteSpace(Nome)

        Console.ReadLine()
    End Sub

    Private Sub CadastrarPessoaNoBanco(pessoa As Pessoa)
        'Using Conn = New System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;")
        '    Conn.Open()
        '    If Conn.State = System.Data.ConnectionState.Open Then
        '        Using Comm = New System.Data.SQLite.SQLiteCommand("INSERT INTO Pessoa (Nome, Sobrenome) VALUES (@Nome, @Sobrenome)", Conn)
        '            Comm.Parameters.AddWithValue("Nome", pessoa.Nome)
        '            Comm.Parameters.AddWithValue("Sobrenome", pessoa.Sobrenome)
        '            Comm.ExecuteNonQuery()
        '        End Using
        '    End If
        'End Using

        'Using Conn = New System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;")
        '    Conn.Open()
        '    If Conn.State = System.Data.ConnectionState.Open Then
        '        Conn.Execute("INSERT INTO Pessoa (Nome, Sobrenome) VALUES (@Nome, @Sobrenome)", New With
        '        {
        '            .Nome = pessoa.Nome,
        '            .Sobrenome = pessoa.Sobrenome
        '        })
        '    End If
        'End Using

        Using Conn = New System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;")
            Conn.Open()
            If Conn.State = System.Data.ConnectionState.Open Then
                Conn.Insert(pessoa)
            End If
        End Using
    End Sub
    Private Sub ListarPessoas()
        Console.WriteLine("======= Listagem de pessoas =======")

        Dim Pessoas = CarregarPessoasDoBanco()
        For Each Pessoa In Pessoas
            Console.WriteLine("Id: {0}, Nome: {1}, Sobrenome: {2}", Pessoa.Id, Pessoa.Nome, Pessoa.Sobrenome)
        Next

        Console.WriteLine("===================================")
    End Sub
    Private Function CarregarPessoasDoBanco() As IEnumerable(Of Pessoa)
        'Dim Pessoas = New List(Of Pessoa)()

        'Using Conn = New System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;")
        '    Conn.Open()
        '    If Conn.State = System.Data.ConnectionState.Open Then
        '        Using Comm = New System.Data.SQLite.SQLiteCommand("SELECT * FROM Pessoa", Conn)
        '            Using Reader = Comm.ExecuteReader()
        '                While Reader.Read()
        '                    Dim Pessoa = New Pessoa()
        '                    Pessoa.Id = Convert.ToInt32(Reader("Id"))
        '                    Pessoa.Nome = Reader("Nome").ToString()
        '                    Pessoa.Sobrenome = Reader("Sobrenome").ToString()
        '                    Pessoas.Add(Pessoa)
        '                End While
        '            End Using
        '        End Using
        '    End If
        'End Using

        'Return Pessoas

        Dim Pessoas As IEnumerable(Of Pessoa) = Nothing

        Using Conn = New System.Data.SQLite.SQLiteConnection("Data Source=db.db;Version=3;")
            Conn.Open()
            If Conn.State = System.Data.ConnectionState.Open Then
                'Pessoas = Conn.Query(Of Pessoa)("SELECT * FROM Pessoa")
                Pessoas = Conn.GetAll(Of Pessoa)()
            End If
        End Using

        Return Pessoas
    End Function
End Module
